extern char* DoRule(char* CodePos, char* Symbol, int tCompressed, char* tSymbolName = NULL, bool bnot = false);
extern char* pInitSymbol;

extern "C" char* pTree;
extern int nTreeSize;
extern "C" int nTreeSizeMax;
extern char* SourceBuffer;
extern unsigned long SourceFileSize;

bool bnfinitdone = false;

extern "C" int bnfinit();
extern "C" int bnfparse(char* Source, char** ppTree);
extern "C" int bnfexit();
extern "C" void bnfreset();

int bnfinit()
{
	if (bnfinitdone)
	{
		return(0);
	}

	if (DebugOutput)
	{
		printf("Reading Config\n");
	}
	if (ReadConfig())
	{
		printf("Error Reading Config File\n");
		getchar();
		return(1);
	}

	if (InitGrammar())
	{
		printf("Error Initializing Grammar\n");
		getchar();
		return(1);
	}

	bnfinitdone = true;

	if (DebugOutput) {printf("\n\n");}
	return(0);
}

int bnfparse(char* Source, char** ppTree)
{
	char NearError[96];
	if (DebugOutput)
	{
		printf("Splitting Script\n");
	}

	SourceBuffer = Source;
	SourceFileSize = strlen(Source);

	ErrorBestPos = 0;
	if (DoRule(Source, pInitSymbol, 0) != Source + strlen(Source))
	{
		CopyMemory(NearError, ErrorBestPos, min(95, strlen(ErrorBestPos)));
		NearError[min(95, strlen(ErrorBestPos))] = 0;
		printf("Content does not match Grammar near:\n\n%s\n\n%s\n\n", NearError, Source);
		return(1);
	}
	if (DebugOutput)
	{
		printf("Script Matches Grammar\n");
	}

	if ((*ppTree = (char*) mallocl(nTreeSize, "bnfparse-ppTree")) == 0)
	{
		printf("Memmory Allocaiton Error\n");
		return(1);
	}

	CopyMemory(*ppTree, pTree, nTreeSize);
	bnfreset();

	return(0);
}

void bnfreset()
{
	nTreeSizeMax = 0;
	nTreeSize = 0;
}

int bnfexit()
{
	if (bnfinitdone)
	{
		if (ExitGrammar())
		{
			printf("Error Unloading Grammar\n");
			getchar();
			return(1);
		}

		freel(SymbolNames);
		freel(SymbolPointer);

		freel(lpSeperatorBytes);
		freel(lpComments);

		if (pTree)
		{
			freel(pTree);
		}
		bnfinitdone = false;
	}

	return(0);
}
