unsigned char* lpCodeStart;
int DebugSpare = 0;

clsChar* pCurChar;
clsEquip* pCurEquip;
int nCurFeat;
char *pCurText, *pCurMainText, *pCurSubText;

struct ArgStruct
{
	int type;
	int val;
};

ArgStruct Args[2048];
int ArgCount = 0;

int ParseScript(unsigned char* script, int depth = 0, char* pThisSymbol = "");

char strterm[16];
bool strborderinuse[16];
char strborder[16];
int strstack = 0;

void LockString(unsigned char* Str)
{
	int i = 0;

	if (strstack == 16)
	{
		printf("Fatal Error\nString Stack Exceeded\n");
		quitprog();
	}

	while (Str[i] > 1){i++;}
	strterm[strstack] = Str[i];
	Str[i] = 0;
	if (Str[strlen((char*) Str) - 1] == '\'' || Str[strlen((char*) Str) - 1] == '"')
	{
		strborderinuse[strstack] = true;
		strborder[strstack] = Str[strlen((char*) Str) - 1];
		Str[strlen((char*) Str) - 1] = 0;
	}
	strstack++;
}

void ReleaseString(unsigned char* Str)
{
	strstack--;
	if (strborderinuse[strstack])
	{
		Str[strlen((char*) Str)] = strborder[strstack];
	}
	Str[strlen((char*) Str)] = strterm[strstack];
	strborderinuse[strstack] = false;
}

#include "scriptvar.h"
#include "scriptfuncs.h"
#include "scriptvalset.h"

int EvalExpr(unsigned char* script)
{
	int ArgOld, progress;
	int EvalVal;

	if (DebugOutput) {printf(" Evaluating:");}
	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	if (Args[ArgOld + 1].val == '+')
	{
		EvalVal = Args[ArgOld].val + Args[ArgOld + 2].val;
	}
	else if (Args[ArgOld + 1].val == '-')
	{
		EvalVal = Args[ArgOld].val - Args[ArgOld + 2].val;
	}
	else if (Args[ArgOld + 1].val == '*')
	{
		EvalVal = Args[ArgOld].val * Args[ArgOld + 2].val;
	}
	else if (Args[ArgOld + 1].val == '/')
	{
		EvalVal = Args[ArgOld].val / Args[ArgOld + 2].val;
	}
	else if (Args[ArgOld + 1].val == '%')
	{
		EvalVal = Args[ArgOld].val % Args[ArgOld + 2].val;
	}

	ArgCount = ArgOld;

	Args[ArgCount].type = 0;
	Args[ArgCount].val = EvalVal;
	ArgCount++;

	if (DebugOutput) {printf(" Evaluation Returned %d:", EvalVal);}

	return(progress);
}

inline int EvalMaxMin(unsigned char* script, int Max)
{
	int ArgOld, progress;
	int EvalVal;

	if (DebugOutput) {printf(" Max Function:");}

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	if (Max)
	{
		EvalVal = max(Args[ArgOld].val, Args[ArgOld + 1].val);
	}
	else
	{
		EvalVal = min(Args[ArgOld].val, Args[ArgOld + 1].val);
	}

	ArgCount = ArgOld;
	Args[ArgCount].type = 0;
	Args[ArgCount].val = EvalVal;
	ArgCount++;

	if (DebugOutput) {printf(" Max/Min Returned %d:", EvalVal);}

	return(progress);
}

int EvalMax(unsigned char* script)
{
	return(EvalMaxMin(script, 1));
}

int EvalMin(unsigned char* script)
{
	return(EvalMaxMin(script, 0));
}

void LockCharToInt(int nArg)
{
	int converttemp;

	if (Args[nArg].type == 1)
	{
		LockString((unsigned char*) Args[nArg].val);
		converttemp = atoi((char*) Args[nArg].val + 1);
		ReleaseString((unsigned char*) Args[nArg].val);
		Args[nArg].val = converttemp;
		Args[nArg].type = 0;
	}
}

int condition_types(unsigned char* script)
{
	int progress;
	progress = ParseScript(script, 1);

	if(*script == 1 && *(script + 5) == 1 && strcmp(Source.lpSymbolStart + *((int*) (script + 6)), "condition_inverse") == 0)
	{
		Args[ArgCount - 1].val = !Args[ArgCount - 1].val;
	}

	return(progress);
}

int condition_all(unsigned char* script)
{
	int progress, ArgOld;
	
	ArgOld = ArgCount;
	progress = ParseScript(script, 1);

	if (ArgCount == ArgOld + 3)
	{
		if (Args[ArgOld + 1].val == '&')
		{
			Args[ArgOld].val = Args[ArgOld].val && Args[ArgOld + 2].val;
		}
		else if (Args[ArgOld + 1].val == '|')
		{
			Args[ArgOld].val = Args[ArgOld].val || Args[ArgOld + 2].val;
		}
		else
		{
			printf("Fatal Scripting Error\n");
			quitprog();
		}
		ArgCount = ArgOld + 1;
	}

	return(progress);
}

int condition(unsigned char* script)
{
	int progress, ArgOld;
	int Result;
	int comparetype;

	bool ConvertToInt = false;

	if (DebugOutput) {printf(" Checking condition:");}

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	LockString((unsigned char*) Args[ArgOld + 1].val);
	comparetype = TwoCharToInt((char*) Args[ArgOld + 1].val, true);
	ReleaseString((unsigned char*) Args[ArgOld + 1].val);

	if (comparetype != TwoCharToInt("==") && comparetype != TwoCharToInt("!="))
	{
		ConvertToInt = true;
	}
	if (Args[ArgOld].type == 0 || Args[ArgOld + 2].type == 0)
	{
		ConvertToInt = true;
	}

	if (ConvertToInt)
	{
		LockCharToInt(ArgOld);
		LockCharToInt(ArgOld + 2);
	}

	if (comparetype == TwoCharToInt("==") || comparetype == TwoCharToInt("!="))
	{
		if (Args[ArgOld].type == 0)
		{
			Result = (Args[ArgOld].val == Args[ArgOld + 2].val);
		}
		else
		{
			LockString((unsigned char*) Args[ArgOld].val);
			LockString((unsigned char*) Args[ArgOld + 2].val);
			Result = (strcmp((char*) Args[ArgOld].val + 1, (char*) Args[ArgOld + 2].val + 1) == 0);
			ReleaseString((unsigned char*) Args[ArgOld + 2].val);
			ReleaseString((unsigned char*) Args[ArgOld].val);
		}
		if (comparetype == TwoCharToInt("!="))
		{
			Result ^= 1;
		}
	}
	else if (comparetype == TwoCharToInt("<="))
	{
		Result = (Args[ArgOld].val <= Args[ArgOld + 2].val);
	}
	else if (comparetype == TwoCharToInt(">="))
	{
		Result = (Args[ArgOld].val >= Args[ArgOld + 2].val);
	}
	else if (comparetype == '<')
	{
		Result = (Args[ArgOld].val < Args[ArgOld + 2].val);
	}
	else if (comparetype == '>')
	{
		Result = (Args[ArgOld].val > Args[ArgOld + 2].val);
	}
	
	ArgCount = ArgOld;

	Args[ArgCount].type = 0;
	Args[ArgCount].val = Result;
	ArgCount++;
	
	return(progress);
}

int sIfDone[256];
int sIfApplied[256];
int sIfStack = -1;

int sIf(unsigned char* script)
{
	int ArgOld, progress;

	if (DebugOutput) {printf(" Doing If conditional Order:");}

	if (sIfStack == 255)
	{
		printf("Fatal Error\nIf Stack exceeded\n");
		quitprog();
	}

	sIfStack++;
	sIfDone[sIfStack] = 0;

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	sIfStack--;

	ArgCount = ArgOld;

	if (DebugOutput) {printf(" If conditional Order ended:");}

	return(progress);
}

int sWhile(unsigned char* script)
{
	int progress, ArgOld;

	if (DebugOutput) {printf(" Doing While Order:");}

	if (sIfStack == 255)
	{
		printf("Fatal Error\nIf Stack exceeded\n");
		quitprog();
	}

	ArgOld = ArgCount;

	sIfStack++;
	sIfDone[sIfStack] = 0;
	sIfApplied[sIfStack] = 1;

	while (sIfApplied[sIfStack])
	{
		sIfApplied[sIfStack] = 0;
		progress = ParseScript(script, 1);
	}
	
	sIfStack--;
	ArgCount = ArgOld;

	if (DebugOutput) {printf(" While Order ended:");}

	return(progress);
}

int SkipScript(unsigned char* script, int num = 1)
{
	int i = 0;

	do
	{
		if (script[i] == 0)
		{
			num--;
			i++;
		}
		else if (script[i] == 1)
		{
			num++;
			i += 5;
		}
		else
		{
			while (script[i] > 1)
			{
				i++;
			}
		}
	}
	while (num);

	return(i);
}

inline int sIfa(unsigned char* script, int condition)
{
	int ArgOld, progress;
	int DoThis;

	ArgOld = ArgCount;

	if (DebugOutput) {printf(" If block found:");}

	if (sIfDone[sIfStack])
	{
		if (DebugOutput) {printf(" Skipping block:");}
		progress = SkipScript(script);
	}
	else
	{
		progress = ParseScript(script);
		if (condition)
		{
			if (DebugOutput) {printf(" Checking condition:");}
			progress += ParseScript(script + progress);
			DoThis = Args[ArgCount - 1].val;
		}
		else
		{
			if (DebugOutput) {printf(" No condition (Else block):");}
			DoThis = 1;
		}
		ArgCount = ArgOld;

		if (DoThis)
		{
			if (DebugOutput) {printf(" Performing block:");}
			sIfDone[sIfStack] = 1;
			progress += ParseScript(script + progress);
			progress += ParseScript(script + progress);
			progress += SkipScript(script + progress);
			sIfApplied[sIfStack] = 1;
		}
		else
		{
			if (DebugOutput) {printf(" Condition did not aply:");}
			progress += SkipScript(script + progress);
			sIfApplied[sIfStack] = 0;
		}
	}

	if (DebugOutput) {printf(" If block ended:");}

	ArgCount = ArgOld;
	return(progress);
}

int sIfa_i(unsigned char* script)
{
	return(sIfa(script, 1));
}

int sIfa_e(unsigned char* script)
{
	return(sIfa(script, 0));
}

int sFor(unsigned char* script)
{
	int progress, ArgOld;
	int pos_condition, pos_increment, pos_order;
	int loopok;

	ArgOld = ArgCount;

	progress = ParseScript(script); //"for("
	progress += ParseScript(script + progress); //valset
	progress += ParseScript(script + progress); //";"

	pos_condition = progress;
	progress += SkipScript(script + progress, 0); //condition

	progress += ParseScript(script + progress); //";"

	pos_increment = progress;
	progress += SkipScript(script + progress, 0); //increment

	progress += ParseScript(script + progress); //"){"

	pos_order = progress;

	do
	{
		ParseScript(script + pos_condition);
		ArgCount--;
		if (Args[ArgCount].val == 1)
		{
			progress = ParseScript(script + pos_order);
			ParseScript(script + pos_increment);
			loopok = 1;
		}
		else
		{
			progress += pos_order + SkipScript(script + pos_order + progress);
			loopok = 0;
		}
	} while (loopok);

	ArgCount = ArgOld;
	return(progress);
}

int SetEquip(unsigned char* script)
{
	int i;
	for (i = 0;i < pCurChar->EquipCount;i++)
	{
		if (pCurChar->Equipment[i].ID == pCurChar->FeatDependancy[nCurFeat])
		{
			pCurEquip = &pCurChar->Equipment[i];
			goto Found;
		}
	}
	pCurEquip = &eDumpEquip;
Found:
	return(ParseScript(script, 1));
}

int DoAllEq(unsigned char* script)
{
	int i, progress;
	clsEquip* EquipOld;
	EquipOld = pCurEquip;

	if (pCurChar->EquipCount)
	{
		for (i = 0;i < pCurChar->EquipCount;i++)
		{
			pCurEquip = &pCurChar->Equipment[i];
			progress = ParseScript(script, 1);
		}
	}
	else
	{
		progress = SkipScript(script, 1);
	}

	pCurEquip = EquipOld;
	return(progress);
}

#include "scriptextract.h"
#include "scriptredir.h"

int ParseScript(unsigned char* script, int depth, char* pThisSymbol)
{
	int i;
	char* pSymbol;
	char DebugTemp[8];

	DebugSpare++;

	i = 0;
	do
	{
		if (script[i] == 0)
		{
			i++;
			depth--;
		}
		else if (script[i] == 1)
		{
			i++;
			pSymbol = (char*) Source.lpSymbolStart + *((int*) &script[i]);
			i += sizeof(int);

			if (DebugOutput)
			{
				sprintf(DebugTemp, "%%%ds", DebugSpare * 2);
				printf("\n");
				printf(DebugTemp, "");
				printf("%4d - %s:", (&script[i] - lpCodeStart - 5), pSymbol);
			}

			if (*((int*) (RedirFuncs + *((int*) &script[i - sizeof(int)]))))
			{
				i += ((int(*)(unsigned char*)) *((int*) (RedirFuncs + *((int*) &script[i - sizeof(int)]))))(&script[i]);
			}
			else
			{
				i += ParseScript(&script[i], 1, pSymbol);
			}
		}
		else
		{
			char CharOut[2] = " ";
			while (script[i] > 1)
			{
				CharOut[0] = script[i];
				if (DebugOutput) {printf("%s", CharOut);}
				i++;
			}
		}
	} while (depth > 0);

	if (*pThisSymbol && *((int*) (RedirExtract + (pThisSymbol - Source.lpSymbolStart))))
	{
		((int(*)(int)) *((int*) (RedirExtract + (pThisSymbol - Source.lpSymbolStart))))((int) script);
	}

	DebugSpare--;

	return(i);
}

int RunScript(clsChar* TargetStruct, clsEquip* TargetStructE, char* TextOutput, char* script, int Feat = -1, char* SubText = NULL)
{
	lpCodeStart = (unsigned char*) script;

	pCurChar = TargetStruct;
	pCurEquip = TargetStructE;
	pCurText = TextOutput;
	pCurMainText = TextOutput;
	pCurSubText = SubText;
	nCurFeat = Feat;

	return(ParseScript(lpCodeStart));
}
