int SourceInit()
{
	int tmp;

	if (SourceInitDone)
	{
		return(0);
	}

	ZeroMemory(&Source, sizeof(clsSource));
	Source.lpSymbolStart = bnf::SymbolNames;

	if (SourceInit<clsDomainSource>(DOMAIN_FILE, &Source.DomainSource, &Source.DomainSourceCount, &SetDomainSource)) {return(1);}
	if (SourceInit<clsMonsterTypeSource>(MONSTER_TYPE_FILE, &Source.MonsterTypeSource, &Source.MonsterTypeSourceCount, &SetMonsterTypeSource)) {return(1);}
	if (SourceInit<clsRegionSource>(REGION_FILE, &Source.RegionSource, &Source.RegionSourceCount, &SetRegionSource)) {return(1);}
	if (SourceInit<clsSchoolSource>(SCHOOL_FILE, &Source.SchoolSource, &Source.SchoolSourceCount, &SetSchoolSource)) {return(1);}
	if (SourceInit<clsSizeSource>(SIZE_FILE, &Source.SizeSource, &Source.SizeSourceCount, &SetSizeSource)) {return(1);}
	if (SourceInit<clsTemplateSource>(TEMPLATE_FILE, &Source.TemplateSource, &Source.TemplateSourceCount, &SetTemplateSource)) {return(1);}
	if (SourceInit<clsSpecialSource>(SPECIAL_FILE, &Source.SpecialSource, &Source.SpecialSourceCount, &SetSpecialSource)) {return(1);}
	if (SourceInit<clsBonusSource>(BONUS_FILE, &Source.BonusSource, &Source.BonusSourceCount, &SetBonusSource)) {return(1);}

	Source.AttributeNames[0] = "Strke";
	Source.AttributeNames[1] = "Geschicklichkeit";
	Source.AttributeNames[2] = "Konstitution";
	Source.AttributeNames[3] = "Intelligenz";
	Source.AttributeNames[4] = "Weisheit";
	Source.AttributeNames[5] = "Charisma";

	if (SourceInit<clsCharSource>(CHAR_FILE, &Source.CharSource, &Source.CharSourceCount, &SetCharSource)) {return(1);}
	ClassPosition = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SourceInit-ClassPositions");
	if (SourceInit<clsRaceSource>(RACE_FILE, &Source.RaceSource, &Source.RaceSourceCount, &SetRaceSource, 1)) {return(1);}
	RacePosition = (int*) mallocl(Source.RaceSourceCount * sizeof(int), "SourceInit-RacePositions");
	if (SourceInit<clsFeatSource>(FEAT_FILE, &Source.FeatSource, &Source.FeatSourceCount, &SetFeatSource)) {return(1);}
	if (SourceInit<clsSkillSource>(SKILL_FILE, &Source.SkillSource, &Source.SkillSourceCount, &SetSkillSource)) {return(1);}
	
	if (SourceInit<clsSpellSource>(SPELL_FILE, &Source.SpellSource, &Source.SpellSourceCount, &SetSpellSource)) {return(1);}
	if (SourceInit<clsSourceFake>(SPELL_FILE_2, NULL, &tmp, &SetSpellSource2, 0, true)) {return(1);}
	CopySpellList();

	if (SourceInit<clsPowerSource>(POWER_FILE, &Source.PowerSource, &Source.PowerSourceCount, &SetPowerSource)) {return(1);}
	if (SourceInit<clsEffectSource>(EFFECT_FILE, &Source.EffectSource, &Source.EffectSourceCount, &SetEffectSource)) {return(1);}
	if (SourceInit<clsMonsterSource>(MONSTER_FILE, &Source.MonsterSource, &Source.MonsterSourceCount, &SetMonsterSource)) {return(1);}
	DetermineCR(0, 0, 0, NULL, 0, 1);

	if (SourceInit<clsEquipSource>(EQUIP_FILE, &Source.EquipSource, &Source.EquipSourceCount, &SetEquipSource)) {return(1);}
	for (tmp = 0;tmp < Source.EquipSourceCount;tmp++)
	{
		Source.EquipSource[tmp].Probability = Source.EquipSource[tmp].RaceProbability = 0;
	}
	if (SourceInit<clsSourceFake>(W_PROB_FILE, NULL, &tmp, &SetWProbSource, 0, true)) {return(1);}

	if (SourceInit<clsSpecificSource>(SPECIFIC_FILE, &Source.SpecificSource, &Source.SpecificSourceCount, &SetSpecificSource)) {return(1);}

	if (ProfileSourceInit() == 1) {return(1);}

	Source.RaceSource[Source.RaceSourceCount].Name = "Monster";
	Source.RaceSource[Source.RaceSourceCount].PreferedAttackType = 1;
	Source.RaceSource[Source.RaceSourceCount].Probability = 0;
	Source.RaceSource[Source.RaceSourceCount].Size = 0;

	FillArrayFromFile(START_MONEY_FILE, Source.StartMoney, 100);
	FillArrayFromFile(TREASURE_FILE, Source.Treasure, 100);

	InitMonsterDesc();

	freel(ClassPosition);
	freel(RacePosition);
	SourceInitDone = true;

	return(0);
}

void SourceExit()
{
	int i;

	if (SourceInitDone)
	{
		printf("Freeing Source Data:");
		printf("Chars, ");CharSourceExit();
		printf("Races, ");RaceSourceExit();
		printf("Feats, ");FeatSourceExit();
		printf("Equipment, ");EquipSourceExit();
		printf("Skills, ");SkillSourceExit();
		printf("Spells, ");SpellSourceExit();
		printf("Powers, ");PowerSourceExit();
		printf("Effects, ");EffectSourceExit();
		printf("Monsters, ");MonsterSourceExit();
		printf("Specific, ");SpecificSourceExit();

		printf("Domains, ");DomainSourceExit();
		printf("MonsterTypes, ");MonsterTypeSourceExit();
		printf("Regions, ");RegionSourceExit();
		printf("Schools, ");SchoolSourceExit();
		printf("Size, ");SizeSourceExit();
		printf("Specials, ");SpecialSourceExit();
		printf("Templates, ");TemplateSourceExit();
		printf("Bonuses, ");BonusSourceExit();
		
		printf("Profiles\n");ProfileSourceExit();
	}

	for (i = 0;i < 6;i++)
	{
		Source.AttributeNames[i].~string();
	}

	delete Source.MonsterDesc;

	SourceInitDone = false;
}
